// Autogenerated by @withfig/oclif

const completionSpec: Fig.Spec = {
  name: "onboardbase",
  description:
    "Onboardbase manages app secrets and credentials securely with team work and contractors in mind",
  subcommands: [
    {
      name: "build",
      description: "Run a command with secrets injected into the environment",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        {
          name: ["-p", "--project"],
          description: "Name of project",
          args: { name: "project name" },
        },
        {
          name: ["-e", "--environment"],
          description: "Environment to run by default",
          args: {
            name: "environment",
          },
        },
        {
          name: ["-c", "--command"],
          description: "Command to run",
          args: { name: "Command to Run" },
        },
        {
          name: ["-k", "--prefix"],
          description: "Prefix",
          args: {
            name: "Project Prefix",
          },
        },
        {
          name: ["-s", "--passphrase"],
          description: "Passphrase",
          args: { name: "Encryption Passphrase" },
        },
      ],
      args: { name: "command" },
    },
    {
      name: "config:get-token",
      description: "Get all tokens",
      options: [
        {
          name: ["-S", "--scope"],
          description: "Scope",
          args: { name: "project scope" },
        },
      ],
    },
    {
      name: "config:set",
      description: "Update your onboardbase config",
      options: [
        {
          name: ["-s", "--scope"],
          description: "Scope",
          args: { name: "project scope" },
        },
        {
          name: ["-t", "--token"],
          description: "Auth Token",
          args: { name: "Auth Token" },
        },
        {
          name: ["-A", "--api-host"],
          description: "API Host",
          args: { name: "Api Host" },
        },
        {
          name: ["-D", "--dashboard-host"],
          description: "Dashboard Host",
          args: { name: "Dashboard Host" },
        },
      ],
    },
    {
      name: "config:set-token",
      description: "Set up Configuration token manually",
      options: [
        {
          name: ["-S", "--scope"],
          description: "Scope",
          args: {},
          isRequired: true,
        },
      ],
      args: { name: "token" },
    },
    {
      name: "destroy",
      description:
        "Cleanup Onboardbase artifacts including backup and authentication",
    },
    {
      name: "environment:create",
      description: "Create an environment under a project",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        { name: ["-p", "--project"], description: "Name of project", args: {} },
        {
          name: ["-e", "--environment"],
          description: "Environment Title",
          args: { name: "Environment Name" },
          isRequired: true,
        },
      ],
    },
    {
      name: "login",
      description: "Describe the command here",
      options: [{ name: "--overwrite" }],
    },
    { name: "logout", description: "Log out of the CLI" },
    {
      name: "project:create",
      description: "Create a project",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        { name: ["-t", "--title"], description: "Name of project", args: {} },
        {
          name: ["-d", "--description"],
          description: "Project description",
          args: { name: "Project Description" },
        },
        {
          name: ["-e", "--environment"],
          description: "Environment to run by default",
          args: { name: "default environment" },
        },
      ],
    },
    {
      name: "recommendation:create",
      description: "Create a recommendation",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        {
          name: ["-p", "--project"],
          description: "Name of project",
          args: { name: "project name" },
        },
        {
          name: ["-n", "--note"],
          description: "Note",
          args: { name: "project description" },
        },
      ],
      args: { name: "secrets" },
    },
    {
      name: "secrets",
      description: "Log secrets in JSON file",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        {
          name: ["-p", "--project"],
          description: "Name of project",
          args: { name: "project name" },
        },
        {
          name: ["-e", "--environment"],
          description: "Environment to run by default",
          args: { name: "default environment" },
        },
        { name: ["-J", "--json"], description: "JSON format" },
      ],
    },
    {
      name: "secrets:delete",
      description: "Update secrets on Onboardbase",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        { name: ["-p", "--project"], description: "Name of project", args: {} },
        {
          name: ["-e", "--environment"],
          description: "Environment to run by default",
          args: { name: "Environment to update" },
        },
      ],
      args: { name: "secrets" },
    },
    {
      name: "secrets:update",
      description: "Update secrets on Onboardbase",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        { name: ["-p", "--project"], description: "Name of project", args: {} },
        {
          name: ["-e", "--environment"],
          description: "Environment to run by default",
          args: { name: "Environment to update" },
        },
      ],
      args: { name: "secrets" },
    },
    {
      name: "secrets:upload",
      description: "Upload secrets",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        { name: ["-p", "--project"], description: "Name of project", args: {} },
        {
          name: ["-e", "--environment"],
          description: "Environment to run by default",
          args: { name: "Environment to update" },
        },
      ],
      args: { name: "secrets" },
    },
    {
      name: "setup",
      description: "Setup the Onboardbase CLI for managing secrets",
    },
    {
      name: "share",
      description: "Share your local onboardbase.yaml secrets with a teammate",
      options: [
        { name: ["-h", "--help"], description: "Show CLI help" },
        {
          name: ["-p", "--project"],
          description: "Project name",
          args: { name: "project name" },
        },
      ],
    },
    {
      name: "help",
      description: "Display help for <%= config.bin %>",
      options: [{ name: "--all", description: "See all commands in CLI" }],
      args: {
        name: "command",
        description: "Command to show help for",
        isOptional: true,
      },
    },
  ],
};

export default completionSpec;
